The Engineering Ladder is our way to provide people a professional growth path. 
What is needed to advance to the next level and get a promotion is well explained and explicit (transparency).

Our Path is composed of seven levels. The first four are the same for everyone, while the last three are different for tech and manager tracks, as shown in the below image.


<iframe src="images/ladder/career ladder 2025.pdf" width="100%" height="600px">
</iframe>


The Engineering ladder is not related to self-management roles. Self-management roles are needed by the organization, while each individual requires ladder levels to grow as a professional. It helps to develop skills across four main directions:
* Dex - Technical skills
* Str - Get Stuff Done
* Wis - Impact
* Cha - Communication & Leadership

The extended document is located in BigData Sharepoint / Career Ladder and it will be updated and releases every six months by the `role:Engine/COO`

This ladder was built taking inspiration mainly from the "rent the runaway" ladder and many others. Thanks


### Rules

* Expectations at each level are cumulative
* Managers have the same expectations as individual contributors to the extent that they are doing individual work, in addition to manager-specific expectations
*  Dex and Str ( the «adder» attributes) are the primary drivers of promotions at lower levels. At higher levels, the 
importance gradually shifts to Wis and Cha ( the «multiplier» attributes )
* Not everyone will progress in each column in lockstep. If you are Eng4 for Dex and Eng2 for Cha, you will not be stuck at Eng2, but you will likely not be promoted all the way to Eng4.  Higher levels require full compliance. 
* To advance to the next level, you need to consistently perform at that level for some time (6M – 1Y) and then 
needed by the organization
* Once hired, the assigned level cannot reviewed without doing the process ( including the previous point ), so it will require a minimum of 6M - 1Y to consistently perform at the next level.
* It is not possible to bump two or more levels in one shot
* To reach Engineer 3, a positive experience as Project/Team leader is helpful
* Pay attention to senior traits and quotas to advance to L3+​
* To reach Engineer 4 or above, an extensive experience as project/team leader is almost mandatory
* Each level has a compensation range associated. If you are stuck in a level, you can anyway move forward your compensation, but only up to the upper limit.
* Ladder levels are not applied to external consultants hired by other companies. Those hired remotely (E2 contracts) are instead included in the ladder mechanism. See [Contracts](Contracts) for details.
* For higher levels, it is not sufficient to demonstrate skill but is necessary to act consistently, generating a tangible impact. Very often is not possible to create such an impact without having the possibility to serve in specific roles. We don't want people doing activities for ladder climbing and not for the company's needs.
* In order to move from Engineer Rookie to Eng 1 the coach approval is sufficient.​
* Each level has a minimum working experience requirement ( years ). Minimum working experience is just an hard gate. There are no upper limits in ladder levels. It is possible to remain forever in a level; no improvements, no promotion.
* Not all the people can be promoted to the higher levels.
* Retention Pack is a one time payment delivered at 31/03 of each year. The employee as of 31/03 must still be within the company and employed for more than one year. Retention Pack is only for employees ( E1, E2 )
* Roles above Eng4 ( Ex. Engineering Manager and Staff Engineers ) must have E1 contract
* Each level has an intersection matrix with company roles
* A level with an \* means that before being considered fully at that level there is some weakness to fix. The \* can be assigned only after the hiring process, not during the normal evolution in the company
* After a level has been assigned during the hiring process, the next level must be demonstrated in the context of Agile Lab ( no past experiences will be considered )
* Some level has specific needs based on the technical specialization. The ladder is suitable for the following macro-specializations:
    - DE: Data Engineer: Create and industrialize Data Platforms or Data centric use cases
    - DS: Data Scientist: Create and industrialize ML based use cases, fitting them in a broader picture and ecosystem
    - DA: Data Analyst: Perform ad-hoc analysis, reporting, dashboards and light data transformations / data modelling
    - FS: Full Stack Engineer: Creates Microservices, API or end-to-end Web Applications.
    - SRE: Site Reliability Engineer: Monitor, Automate and Manage infrastructures and applications
* It is not necessary to strictly fit on one of these profiles, cross-functionality is a value, and for example we can evaluate an Eng3 for both DE and DA, weighting the evaluations
* On the Product side, expectations are the same for lower levels, but for the complexity we need to manage at the moment, upper levels are not necessary and targeting consulting only. ( This will be reviewed in the future )


## Post Recruiting

* Not possible to re-evaluate the result and ladder placement of the hiring process before 6 months
* After 6 months there is a formal ladder confirmation process where the candidate is not involved
    * The coach and the interviewer go through an assessment to re-evaluate the original ladder positioning. The following things can happen:
        * Ladder level confirmed: nothing changes and the candidate need to climb the ladder
        * Ladder level down-grade: the ladder level remains the same but with an \*. In order to clear the \*, the candidate need to wait the coach confirmation without doing a formal ladder climbing
        * Ladder level up-grade: New ladder level assigned and RAL adjusted if needed
    * In case of down-grade the coach and the interview need to explain clearly which are the points not matched on the ladder, providing clear direction and guidance on how to fix that. Remember the ladder level need to be fair for the community, at individual level you need to focus on the improvement journey
    * Is not possible to do a down-grade without previous negative feedbacks and coaching tips, along the 6 previous months coaching journey




## Promotion philosophy

When is possible we approach things to bottom-up and with self-responsibility in mind. 
**Promotions are based on actual and consistent performances, not growth potential**. In order to be considered for a promotion the candidate should be executing at the next level prior to promotion.

The promotion is just a milestone in a long-term journey and it is the result of a growth process in partnership with the coach. Personal growth should be a frequently discussed item during 1-1 meetings, without creating the false expectation that because talking about growth then it means we are close to the next milestone. The coach should be super transparent in dealing with team member expectations, performances and improvements.

**Without consistent improvements and next ladder level performances, there will not be promotion**, no matter how long the team member is stuck in a ladder level. Fitting with the minimum working experience required for a specific ladder level is not an indication to be eligible for that level, **the past working years are not a driver for the promotion**.


### How to get promoted

* If you want to be promoted, you need to assess yourself and convince your coach that you are ready
* Ask your coach to assess with the Consulting Engineering Director or Witboost Lead Link if there is quota into the next level and then present your candidacy sending an email to the upper lead link. They will prioritize requests in case of multiple applications for a level that has no enough capacity. Within the candidacy you can attach your brag file or other kind of documentation that is demonstrating your target level.
* Your coach  will mentor you along the process, helping to build the brag file to support your pitch 
* Pitch will be done to a specific committee.
* if your mentor is not coaching you enough, please keep him/her accountable

By default, the coach is your project leader (or the lead link).
However, project leaders and lead links can delegate the coaching responsibilities to other team members they consider suitable for the role to ensure optimal coaching in the long term.

The coach has a huge responsibility in this process:
- if a candidate is not ready to apply for the next level and the coach does not detect it, it can cause a huge demotivation effect in case it is not promoted
- If a candidate is ready, but is not self-confident to apply for the promotion, could be demotivating as well because no-one is recognizing its value
- Coach must be super transparent and should always coach to reach the goal, but should not to sponsor a not ready candidate.

### When to get promoted

The candidate can apply to pitch at the beginning of each quarter within a two weeks window, and the candidacy must be presented at least one month before. 
For example if you want to pitch at the beginning of April (End Q1), the application must be done before the end of February.


### The brag file

Not all the people in the committee are aware of what the candidate is doing and how she/he is performing. The ladder is composed by a list of expectations that the candidate needs to fulfill. Most of them are soft or not easy to demonstrate in an interview, so the candidate should build a brag file with its major achievements and how these are fulfilling the ladder requirements. It is also a matter of transparency. 

The brag file should be a sharable document and it must be shared with the committee at least one week before the pitch, so they can prepare questions and can have a clear overview about it.
The document should be self-explanatory and should demonstrate that candidate is acting at the target level since 6-12 months with consistency. Put focus on generated impact and major achievements, the brag file should not be more than 5 pages/slides and should not require more than 40 hours of work ( you can use working hours to prepare your brag because it is a crucial part of your personal growth ). Working hours used for the brag file have to be tracked on the Elapseit project [People Growth](https://app.elapseit.com/management/project-details/36165). The side goal of the brag file is to raise awareness in the candidate, identify weak points and improvement paths.

Especially for higher levels, it is crucial to focus more on impact and outcomes than actions and self-referential items. For example, don't report "I created a new process for code reviews" without mentioning the positive impact of code review effectiveness and the level of adoption of this new practice within the company.
Because not all the ladder requirements can be documented the coach can certify for the candidate that he/she is compliant ( possibly with a cover letter ) or the committee can decide to ask questions about a specific topic to properly assess it. 

### Promotion Committee

We want to distribute the accountability and don't let a single person judge for a promotion, limiting the judgment bias and the candidate's frustration against a single person.

The following roles will compose the committee:
- The Consulting Engineering Director or Witboost Lead Link plus two other components ( choosen by first one ) (at least Eng 4.)
- The candidate's coach (project leader/lead link)
- the lead link of the candidate's coach (upper lead link)
- 2 team members (or former team members) of the candidate, chosen by him/her. (if you are not in the position to pick up two team members, explain why and proceed anyway)

When a candidate want to schedule the pitch, the coach will ask the lead link of Consulting or Witboost to compose the committee and schedule the pitch.

### How to propose an application

The lead link of the candidate's coach:
- Calls for a meeting to compose the Promotion Committee sending an email to the Lead Link of Consulting or Witboost and two eligible other members at her/his choice
- Puts the candidate and her/his Coach in cc and attaches brag file and presentation
- Additionally, can anticipate the two members chosen by the candidate in cc

The lead link of the candidate's coach is also responsible to schedule the meeting taking into account everyone's availability.

The Coach answers with a cover letter for the candidate.

The period between the application and the meeting with the Promotion Committee will be used by the Committee members to review the material and provide further inputs before the presentation.


### The Pitch

The pitch is a meeting among peers, it is not an interview but the committee will ask questions about the brag file or will assess open points. The pitch and the brag file should focus only on expectations points that coach or the committee think must be proven.

After the pitch of the candidate, the committee will express an evaluation in the following way:
* Technical Skills: coach + two senior engineers from Consulting/Witboost circle (at least Eng 4)
* Get Stuff Done: coach + team members
* Impact: coach + upper lead link
* Communication & Leadership: coach + upper lead link + team member

To get the promotion on each feature, you need to reach unanimity and the result will be given immediately after the pitch.

If you get not promoted, you will receive extended feedback about motivations and what you should focus on to get there.


### Compensation
The [compensation](SalaryReview.md) must always be decided by a person that is possibly two levels ( of the ladder) above the promotion's candidate's target level, during the salary review process.


### Ladder Governance

The ladder is governed by the CTO that is responsible for:
* Adapting the ladder level compensation ranges to stay competitive and pay top of our reference market
* Modyfing the ladder level definitions aligning them to what is important to drive the growth of the company

The ladder can be modified in every moment, because a crucial steering mechanism to stay competitive in the market, with the following process:
1) CTO creates a new version of the ladder and publish it in the BigData Sharepoint, where we keep the full history of this document
2) CTO sends a company comunication to notify the change
3) CTO updates this Handbook page to make the change transparent also to the external world
4) CTO detects needed salary raises in case of compensation range modifications and communicate them to HR, as a normal salary raise
5) HR modifies all the open job positions to align them to the new compensation ranges and expectations


The CTO run periodically discussions with Engineering Director and BU Leads to understand if ladder level definitions are matching the company needs.


### Compensation ranges

These ranges are calculated by the CTO taking in consideration the following criteria:

* The percentage of success in hiring people at each specific level relying on the level compensation range. The CTO analyzes the hiring proposal records to define if Agile Lab is competitive or not in the job market
* Investigation on Glassdoor and other information sources about compnesation ranges for specific job titles

All these information are tracked and versioned periodically.

